import json
from optparse import OptionParser
import numpy as np
import matplotlib.pyplot as plt
from glob import glob

np.set_printoptions(precision=3, suppress=1)

fnames = glob('test.seed*.txt')
fnames.sort()


#for ii, fname in enumerate(fnames):
arrays = {}
fig = plt.figure()
ax = fig.add_subplot(111)
#fig2 = plt.figure()
#ax2 = fig2.add_subplot(111)

xname = 'R0'
yname = 'sigma_homolumo'
zname = 'err'

#X = []
#Y = []
allZ = []


for ii, fname in enumerate(fnames):
    with open(fname) as fd:
        data = [json.loads(line) for line in fd]
        keys = list(data[0].keys())
        if ii == 0:
            X = np.array([d[xname] for d in data])
            Y = np.array([d[yname] for d in data])
            #Z = np.zeros_like(Y)
        allZ.append(np.array([d[zname] for d in data]))

allZ = np.array(allZ)
Zstd = allZ.std(axis=0)
Z = allZ.mean(axis=0)
        #for key in keys:
        #    arrays[key] += np.array([d[key] for d in data])

#X = arrays[xname]
#Y = arrays[yname]
#for ax0 in ax, ax2:
ax.set_xlabel(xname)
ax.set_ylabel(yname)
ax.set_title(zname)

x = np.unique(X)
y = np.unique(Y)

nx = len(x)
ny = len(y)
X = X.reshape(nx, ny)
Y = Y.reshape(nx, ny)
#Z = arrays[zname]
Z = Z.reshape(nx, ny)
Z = Z.reshape(nx, ny)

#Z.clip(0.0, 0.8)
contour = ax.contourf(X, Y, Z.clip(0.0, 0.8),
                      64 * 2)
#contour = ax.contourf(X, Y, np.log(np.gradient(Z)[0]**2).clip(-np.inf, -5.), 64)


#contour2 = ax2.contourf(X, Y,
#                       np.abs(np.gradient(Z)[0])**.1, 64)
#ax.set_xscale('log')
#for ax0 in ax, ax2:
ax.set_xscale('log')
ax.set_yscale('log')
#ax.axis(xmax=1e8)
#for fig in con in contour, contour2:
#    plt.colorbar(contour)
fig.colorbar(contour)
#fig2.colorbar(contour2)
#ax2.set_title('abs derivative wrt. R0 of error: |d[err]/d[R0]|')

#ax.semilogx(arrays[xname], arrays[yname], 'o-')
#fig.savefig('output.seed{:02d}.png'.format(ii))
#ax.set_xlabel(xname)
#ax.set_ylabel(yname)

plt.show()
